----------------------------------------------------------------------------------------------------
-- ubNf[^
--   蔻擾Ƃ̏ł
--   Lq@̓TvQlɓKɎ@Ă
----------------------------------------------------------------------------------------------------

--[[
	ԍ		: O			SMW^Cԍ
	0x000 ` 0x0fe	: uN^C	025
	0x0ff		: S[^C		
	0x100 ` 0x1ff	: ubN^C	130
	0x200 ` 0x2ff	: ACe^C	
	0x300 ` 0x3ff	: 



]]

--------------------------------------------------
m_block = {}
t_block = {}

--------------------------------------------------

-- vC[Ƃ̋
function t_block.get_playerdistance(page,pbx,pby)
	local bs	= game.system.block_size
	local hbs	= bs/2
	local pbxn	= 16
	local dstx	= (player.x - ((page*pbxn+pbx)*bs+hbs))
	local dsty	= (player.y - (pby*bs+hbs))
	return dstx,dsty
end

-- vC[Ƃ4̐ڐGԂԂ܂
function t_block.get_coldet(page,pbx,pby)
	local cold	= {}
	local hbs	= game.system.block_size/2 +1
	local dstx,dsty = t_block.get_playerdistance(page,pbx,pby)
	local adx, ady	= math.abs(dstx), math.abs(dsty)

	local c		= (adx<=hbs and ady<=hbs)

	cold.left	= (c and dstx<=0)
	cold.right	= (c and dstx>=0)
	cold.top	= (c and dsty<=0)
	cold.bottom	= (c and dsty>=0)

	return cold

end

-- @Ƃ̓
function t_block.strikeup(block, page,pbx,pby)
	local cold = t_block.get_coldet(page,pbx,pby)
	if (block%2==0 and cold.bottom and player.speedy<0) then
		map[page+1][pby+1][pbx+1] = block + 1
		return true
	end
	return false
end



--------------------------------------------------
-- w莞̊ey[WftHg̓

t_block[1] = function (block, page,pbx,pby)	-- blank
	return false
end
t_block[2] = function (block, page,pbx,pby)	-- block
	return true
end
t_block[3] = function (block, page,pbx,pby)	-- item
	t_block.strikeup(block, page,pbx,pby)
	return true
end



--------------------------------------------------
-- ėpȃubÑev[g

function m_block.blank()
	return false
end

function m_block.floor(block, page,pbx,pby, x,y)	-- floor()
	return (y<pby*game.system.block_size)
end

function m_block.goal(block, page,pbx,pby)	-- goal
	local dx,dy	= t_block.get_playerdistance(page,pbx,pby)
	local hbs	= game.system.block_size/2
	local abs	= math.abs

	if (abs(dx)<=hbs and abs(dy)<=hbs)then
		player.goal = true
		map[page+1][pby+1][pbx+1] = 0x000
	end

	return false
end

function m_block.coin(block, page,pbx,pby)	-- coin
	local abs	= math.abs
	local dstx,dsty	= t_block.get_playerdistance(page,pbx,pby)
	local bs	= game.system.block_size
	if (abs(dstx)<bs and abs(dsty)<bs)then
		player.coin = player.coin + 1
		map[page+1][pby+1][pbx+1] = 0x000
	end
	return false
end

function m_block.coinblock(block, page,pbx,pby)	-- coinblock
	if(t_block.strikeup(block, page,pbx,pby))then
		player.coin = player.coin + 1
	end
	return true
end

function m_block.hidden(block, page,pbx,pby)	-- hidden
	if(t_block.strikeup(block, page,pbx,pby))then
		player.y	= (pby+1)*game.system.block_size
		player.speedy	= math.min(0,player.speedy)
		player.coin	= player.coin + 1
	end
	return 	(block%2~=0)
end

function m_block.damage(block, page,pbx,pby)	-- damage
	local abs	= math.abs
	local dstx,dsty	= t_block.get_playerdistance(page,pbx,pby)
	local bs	= game.system.block_size
	if (abs(dstx)<bs and abs(dsty)<bs)then
		game.kill()	-- Ct̊TO܂̂
	end
	return true
end

--------------------------------------------------
-- ʐݒ
--   ftHgƈꍇɒǉĂ

m_block[0x0ff] = m_block.goal

m_block[0x125] = m_block.floor
m_block[0x126] = m_block.floor
m_block[0x127] = m_block.floor
m_block[0x149] = m_block.floor
m_block[0x14a] = m_block.floor

m_block[0x135] = m_block.blank
m_block[0x136] = m_block.blank
m_block[0x137] = m_block.blank


m_block[0x11f] = m_block.coin
m_block[0x12f] = m_block.coin

m_block[0x14b] = m_block.damage
m_block[0x14c] = m_block.damage
m_block[0x14d] = m_block.damage

m_block[0x15e] = m_block.blank

m_block[0x206] = m_block.hidden
m_block[0x20c] = m_block.hidden
m_block[0x20e] = m_block.hidden
m_block[0x216] = m_block.hidden

m_block[0x210] = m_block.coinblock
m_block[0x218] = m_block.coinblock
m_block[0x21a] = m_block.coinblock
m_block[0x21c] = m_block.hidden


m_block[0x280] = m_block.floor
m_block[0x281] = m_block.floor
m_block[0x282] = m_block.floor
m_block[0x283] = m_block.blank
m_block[0x284] = m_block.blank
m_block[0x285] = m_block.blank

m_block[0x2e0] = m_block.damage
m_block[0x2e1] = m_block.damage
m_block[0x2e2] = m_block.damage
m_block[0x2e3] = m_block.damage
m_block[0x2e4] = m_block.damage
m_block[0x2e5] = m_block.damage




